// Moved back to ThinkFrame to ensure
// XMomentum compatibility.

addHook("ThinkFrame", function()
	for player in players.iterate
		if (player.mo and player.mo.valid) and player.mo.skin != "windows" then return
		elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
			if player.isxmomentum == nil or player.normalspeed < skins[player.mo.skin].normalspeed then
				player.normalspeed = skins[player.mo.skin].normalspeed
			end
			if player.powers[pw_invulnerability] != 0 and player.powers[pw_sneakers] == 0 then
				if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 4) / 3 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 4) / 3
				end
			end
			if player.powers[pw_super] != 0 then
				if player.hyper == nil or player.hyper.capable == false then
					if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 3) / 2 then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 3) / 2
					end
				elseif player.hyper.capable == true then
					if player.normalspeed < (skins[player.mo.skin].normalspeed * 7) / 4 then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 7) / 4
					end
				end
			end
			if player.cpanel > 0 and player.playerstate == PST_LIVE then
				if player.exiting != 0 then
					player.cpanel = 0
				end
				P_SpawnGhostMobj(player.mo)
				local r = player.mo.radius/FRACUNIT
				local xy = (P_RandomRange(r, -r)*FRACUNIT)
				local z = (P_RandomKey(player.mo.height/FRACUNIT)*FRACUNIT)
				local smokey = P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_SMOKE)
				smokey.colorized = true
				smokey.color = player.mo.color
				if P_PlayerInPain(player) == true then player.cpanel = 0 end
				if player.exiting != 0 then player.cpanel = 0 end
				if player.powers[pw_super] == 0 then
					if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 15) / 8 then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 15) / 8
					end
					if player.speed < (skins[player.mo.skin].normalspeed * 15) / 8 and P_IsObjectOnGround(player.mo) then
						P_Thrust(player.mo, player.mo.angle, FRACUNIT)
					elseif player.speed < (skins[player.mo.skin].normalspeed * 15) / 8 and not P_IsObjectOnGround(player.mo) then
						P_Thrust(player.mo, player.mo.angle, FRACUNIT/2)
					end
				elseif player.powers[pw_super] != 0 then
					local xbox = P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_WATERZAP)
					if player.hyper == nil or player.hyper.capable == false then
						if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 2) then
							player.normalspeed = (skins[player.mo.skin].normalspeed * 2)
						end
						if player.speed < (skins[player.mo.skin].normalspeed * 2) and P_IsObjectOnGround(player.mo) then
							P_Thrust(player.mo, player.mo.angle, 2*FRACUNIT)
						elseif player.speed < (skins[player.mo.skin].normalspeed * 2) and not P_IsObjectOnGround(player.mo) then
							P_Thrust(player.mo, player.mo.angle, FRACUNIT)
						end
					elseif player.hyper.capable == true then
						if player.normalspeed < (skins[player.mo.skin].normalspeed * 5) / 2 then
							player.normalspeed = (skins[player.mo.skin].normalspeed * 5) / 2
						end
						if player.speed < (skins[player.mo.skin].normalspeed * 5) / 2 and P_IsObjectOnGround(player.mo) then
							P_Thrust(player.mo, player.mo.angle, 3*FRACUNIT)
						elseif player.speed < (skins[player.mo.skin].normalspeed * 5) / 2 and not P_IsObjectOnGround(player.mo) then
							P_Thrust(player.mo, player.mo.angle, 3*FRACUNIT/2)
						end
					end
				end
				player.cpanel = $ - 1
			end
		end
	end
end)